//+------------------------------------------------------------------+
//|          Free and OpenSource code under MIT License              |
//|              (https://opensource.org/licenses/MIT)               |
//|                 Copyright 2018 penyuperwira                      |
//|          (https://www.forexfactory.com/penyuperwira)             |
//|                  updated : 30.09.2018                            |
//+------------------------------------------------------------------+

#property copyright "Hedge at market with TP/SL"
#property show_inputs
//extern int    MagicNumber=274693;
//string info="If 'lots' is set to 0, it will try to use the 'ordersize'";
double fixed_lot=0.01;
double SLpips = 23;
double TPpips = 53;
string    Use_MM_lots="IF you want to decrease lot by";
string    Enable_MM_Percentage_Lots="set Mode_Lots = [1]Fixed [2]%Equity [3]%Balance ";
int      Mode_MM_Lots=3;
//extern bool      Mode_MM_Lots_balance=true;
double    MM_Risk_Percent_Lots=0.25;
double    MM_Lot_Digits_Decimal=2;
extern string info="Set Profit Percent to modify TP/SL";
extern bool      ProfitPercen=true;
extern double    ProfitPercent=1.00;
extern bool      StopPercen=true;
extern double    StopPercent=0.00;
extern bool    ModifyBuy=true;
extern bool    ModifySell=true;
#include <stdlib.mqh>
double pip;
int digits;
double Credit;
double Balance;
double GetoLots;
//+------------------------------------------------------------------+
//| script program start function                                    |
//+------------------------------------------------------------------+
int start()
  {
   double SL,TP,SL2,TP2;
   int i,Total;
   Total=OrdersTotal();
//int err;
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
   double AE=AccountEquity();
//      pl_bal=AE;
//    if(T()==0){ pl_factor=AE/pl_bal; }
//+------------------------------------------------------------------+
   double Bprofit=0,Sprofit=0,BLotsSymbol=0,SLotsSymbol=0;
   for(int j=0; j<OrdersTotal(); j++)
     {
      int ticket2=OrderSelect(j,SELECT_BY_POS,MODE_TRADES);
      if(ticket2<0)//----added by tradercapaym
        {
         // Print("CL-849 , OrderSelect Error: ", GetLastError());
        }
      else
        {
         // Print("CL-853 , Order Select Successfully, Ticket # is : " + OrderTicket());
        }
      // if(cmd()>1) continue;
      if(OrderSymbol()==Symbol() && OrderType()==OP_SELL)Sprofit+=OrderProfit();
      if(OrderSymbol()==Symbol() && OrderType()==OP_SELL)SLotsSymbol+=OrderLots();
      if(OrderSymbol()==Symbol() && OrderType()==OP_BUY) Bprofit+=OrderProfit();
      if(OrderSymbol()==Symbol() && OrderType()==OP_BUY) BLotsSymbol+=OrderLots();

     }
//double tp_m2=Bprofit;
   getpip();
   Credit=AccountCredit();
   Balance=AccountBalance();
//GetoLots=GetLots();
   if(fixed_lot==0) fixed_lot=GlobalVariableGet("ordersize");
   if(fixed_lot==0)
     {
      Alert("!!! "+WindowExpertName()+" "+Symbol()+": 'ordersize' not defined !!!");
     }
//+------------------------------------------------------------------+
   if(Total>0)
     {

      for(i=Total-1; i>=0; i--)
        {
         if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==true)
           {
            if(OrderSymbol()==Symbol() && OrderType()==OP_BUY && ModifyBuy && BLotsSymbol!=0)
              {
               double StopPercentage=(Balance+Credit) *(StopPercent/100);
               double StopPipsMath=NormalizeDouble((StopPercentage-(Bprofit))/((BLotsSymbol)/10),0);
               double ProfitPercentage=(Balance+Credit) *(ProfitPercent/100);
               double ProfitPipsMath=NormalizeDouble((ProfitPercentage-(Bprofit))/((BLotsSymbol)/10),0);
               double SLprice=0;
               double TPprice=0;
               double Price=Bid;
               if(!StopPercen   && SLpips       !=0) SLprice=Price-SLpips*pip;
               if(StopPercen    && StopPercent  !=0) SLprice=Price-StopPipsMath*pip;
               if(!ProfitPercen && TPpips       !=0) TPprice=Price+TPpips*pip;
               if(ProfitPercen  && ProfitPercent!=0) TPprice=Price+ProfitPipsMath*pip;
               if(StopPercent>0) SL=SLprice;  else SL=0; //buy trade
               if(ProfitPercent>0)TP=TPprice;  else TP=0;
               int ticket4=OrderModify(OrderTicket(),OrderOpenPrice(),SL,TP,OrderExpiration(),CLR_NONE);
              }
            if(OrderSymbol()==Symbol() && OrderType()==OP_SELL && ModifySell && SLotsSymbol!=0)
              {
               double StopPercentage2=(Balance+Credit) *(StopPercent/100);
               double StopPipsMath2=NormalizeDouble((StopPercentage2-(Sprofit))/((SLotsSymbol)/10),0);
               double ProfitPercentage2=(Balance+Credit) *(ProfitPercent/100);
               double ProfitPipsMath2=NormalizeDouble((ProfitPercentage2-(Sprofit))/((SLotsSymbol)/10),0);
               double SLprice2=0;
               double TPprice2=0;
               double Price2=Ask;
               if(!StopPercen   && SLpips       !=0) SLprice2 = Price2+SLpips*pip;
               if(StopPercen    && StopPercent  !=0) SLprice2 = Price2+StopPipsMath2*pip;
               if(!ProfitPercen && TPpips       !=0) TPprice2 = Price2-TPpips*pip;
               if(ProfitPercen  && ProfitPercent!=0) TPprice2 = Price2-ProfitPipsMath2*pip;
               if(StopPercent>0) SL2=SLprice2; else SL2=0;//sell trade
               if(ProfitPercent>0)TP2=TPprice2; else TP2=0;
               int ticket5=OrderModify(OrderTicket(),OrderOpenPrice(),SL2,TP2,OrderExpiration(),CLR_NONE);
              }
           }
        }
     }
   return(0);
  }
//--------------------------------------------------------------------------------------
// getpip
//--------------------------------------------------------------------------------------

void getpip()
  {
   if(Digits==2 || Digits==4) pip=Point;
   else if(Digits==3 || Digits==5) pip = 10*Point;
   else if(Digits==6) pip = 100*Point;

   if(Digits==3 || Digits==2) digits=2;
   else digits=4;
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
/* getpip*/

//end
